/*

*/

var angularUntils = {
    
    traverseToProperty: function (scope, propertyName) {
        
        var currentScope = scope.$parent;

        for (var i = 0; i < 150; i++) {

            console.log(currentScope);

            if (currentScope === null) {
                return null;
            }

            if (currentScope[propertyName])
            {
                return currentScope;
            }

            currentScope = currentScope.$parent;
        }
        
        return null;
    }
};



var arrayUtils = {
    /* Removes an item from an array and returns the array without that item. */
    removeElement: function (array, element) {

        var index = array.indexOf(element);
        //Then remove it with splice:

        if (index > -1) {
            array.splice(index, 1);
        }
        return array;
    },
    isInArray: function (searchString, array) {

        var pos = array.indexOf(searchString) > -1;

        return pos;

    }
};

var delimiterDetector = {

    // constants
    comma: ',',
    semicolon: ';',

    detectDelimiter: function (str) {

        // count comma
        var iComma = str.split(delimiterDetector.comma).length;
        // count semicolon
        var iSemicolon = str.split(delimiterDetector.semicolon).length;

        if (iComma >= iSemicolon) {
            return delimiterDetector.comma;
        }
        return delimiterDetector.semicolon;
    }
};
var stringUntils = {

    canonicalizeNewlines: function (str) {
        return str.replace(/(\r\n|\r|\n)/g, '\n');
    },
    toArrayOfRows: function (strText) {
        return stringUntils.canonicalizeNewlines(strText).split("\n");
    },
    isValidEmail: function (email) {

        if (email == null || email === '') {
            return false;
        } else {
            var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            return re.test(email);
        }
    }
};

/* global prototype functions */
String.prototype.trim = function () { return this.replace(/^\s+|\s+$/g, ''); };

String.prototype.ltrim = function () { return this.replace(/^\s+/, ''); };

String.prototype.rtrim = function () { return this.replace(/\s+$/, ''); };

String.prototype.fulltrim = function () { return this.replace(/(?:(?:^|\n)\s+|\s+(?:$|\n))/g, '').replace(/\s+/g, ' '); };
var umbracoUntils = {
    
    currentVersionSameOrAbove: function (strVersionToCompare) {

        var versionToTest = strVersionToCompare.replace(/\./g, "");
        var currentUmbVersionAsNumber = Umbraco.Sys.ServerVariables.application.version.replace(/\./g, "");

        return currentUmbVersionAsNumber >= versionToTest;

    }
};
